/***
 * 
 * Felipe Brahm
 * Ayudante de Ctedra
 * Introduccin a la Programacin - IIC1102 Seccin 4
 * Pontificia Universidad Catlica de Chile
 *
 * lebrahm <at> uc <punto> cl
 * ICQ#50566818
 *
 * (CC)2006
 * 
 * */

import iic1102Package.*;

public class Gato {

	//tamao del tablero del gato: TAM * TAM
	private static int TAM = 3;
	
	public static void main(String[] args) {
		
		int continuar = 1;
		
		Interfaz.MostrarMensaje("Bienvenido al Juego del Gato");
		
		while(continuar == 1) {
			
			Interfaz.MostrarMensaje("Juego Nuevo");
			
			do {
				TAM = Interfaz.PedirEntero("Ingrese el tamao del tablero:");
			} while(TAM <= 2);
			
			/*
			 * 0 -> el juego no ha terminado
			 * 1 -> gan el jugador 1
			 * 2 -> gan el jugador 2
			 * 3 -> empate
			 * */
			int ganador = 0;
			char[][] tablero = new char[TAM][TAM];
			
			//inicializamos el tablero

			for(int i = 0; i < TAM; ++i) {
				
				for(int j = 0; j < TAM; ++j) {
					
					//'_' significar un espacio vaco					
					tablero[i][j] = '_';
					
				}						
				
			}
			
			while(ganador == 0) {

				for(int turno = 1; turno <= 2 && ganador == 0; ++turno) {

					String texto = new String("");

					texto += "Turno del Jugador " + turno;

					texto += "\n\n";
					
					texto += tableroToString(tablero);
					
					texto += "\n\n";
					
					texto += "Para terminar el juego, escriba la palabra: salir";
					
					texto += "\n\n";
					
					texto += "Ingrese las coordenadas de su prxima jugada\nen el formato fila,columna sin espacios:";
					
					texto += "\nEjemplo: 2,3";
					
					String r;
					int x = 0, y = 0;
					do {
						
						do {
							r = Interfaz.PedirString(texto);
						} while(r == null);
						
						if(r.equalsIgnoreCase("salir"))
							return; //terminar el programa
						
						if(r.indexOf(',') != -1) {
							
							String strX, strY;
							
							strX = r.substring(0, r.indexOf(','));
							strY = r.substring(r.indexOf(',') + 1);
							
							if(isInt(strX) && isInt(strY)) {

								x = Integer.parseInt(strX);
								y = Integer.parseInt(strY);
								
								//jugada no vlida
								if(x <= 0 || y <= 0 || x > TAM || y > TAM || tablero[x-1][y-1] != '_')
									x = 0;

							}
							
						}

					} while(x == 0 || y == 0 || x > TAM || y > TAM);
					
					if(turno == 1)
						tablero[x-1][y-1] = 'X';
					else
						tablero[x-1][y-1] = 'O';
					
					ganador = verificarGanador(tablero);
					
				}//for
				
			}//while(ganador...)
			
			if(ganador == 3)
				Interfaz.MostrarMensaje("Ha habido un empate.\n\n" + tableroToString(tablero));
			else
				Interfaz.MostrarMensaje("Enhorabuena!\nHa ganado el jugador " + ganador + ".\n\n" + tableroToString(tablero));
			
			continuar = Interfaz.PedirEntero("Ingre un 1 para seguir jugando o un 0 para salir.");
				
		}//while(continuar)

	}
	
	private static int verificarGanador(char[][] tablero) {
		
		for(int i = 0; i < TAM; ++i) {
			
			int fila = 0;
			
			for(int j = 0; j < TAM - 1; ++j) {
				
				if(tablero[i][j] != '_' && tablero[i][j] == tablero[i][j+1])
					++fila;
				else
					break;
				
			}
			
			if(fila == TAM - 1) {
				
				if(tablero[i][0] == 'X')
					return 1;
				else
					return 2; 
				
			}
				
		}
		
		for(int j = 0; j < TAM; ++j) {
			
			int col = 0;
			
			for(int i = 0; i < TAM - 1; ++i) {
				
				if(tablero[i][j] != '_' && tablero[i][j] == tablero[i+1][j])
					++col;
				else
					break;
				
			}
			
			if(col == TAM - 1) {
				
				if(tablero[0][j] == 'X')
					return 1;
				else
					return 2; 
				
			}
				
		}
		
		//verificar diagonales
		int diag1 = 0;
		int diag2 = 0;

		for(int i = 0; i < TAM - 1; ++i) {
			
			if(tablero[i][i] != '_' && tablero[i][i] == tablero[i+1][i+1])
				++diag1;
			if(tablero[i][TAM-1-i] != '_' && tablero[i][TAM-1-i] == tablero[i+1][TAM-1-i-1])
				++diag2;
				
		}
		
		if(diag1 == TAM - 1) {
			
			if(tablero[0][0] == 'X')
				return 1;
			else
				return 2; 
			
		}
		
		if(diag2 == TAM - 1) {
			
			if(tablero[0][TAM-1] == 'X')
				return 1;
			else
				return 2; 
			
		}
		
		if(tableroToString(tablero).indexOf('_') == -1)
			return 3; //empate
		
		return 0; //el juego no ha terminado
		
	}
	
	//verifica si un string es un entero
	private static boolean isInt(String x) {
		
		if(x.length() == 0)
			return false;
		
		for(int i = 0; i < x.length(); ++i) {
			
			if(x.charAt(i) < '0' || x.charAt(i) > '9')
				return false;
			
		}
		
		return true;
		
	}
	
	//tablero como un String, es decir, desplegable en un mensaje
	private static String tableroToString(char[][] tablero) {
		
		String strTablero = new String("");
	
		for(int i = 0; i < TAM; ++i) {
			
			for(int j = 0; j < TAM; ++j) {
				
				strTablero += " " + tablero[i][j] + " ";
				
			}
			
			strTablero += '\n';
			
		}
		
		return(strTablero);
		
	}

}