/***
 * 
 * Felipe Brahm
 * Ayudante de Ctedra
 * Introduccin a la Programacin - IIC1102 Seccin 4
 * Pontificia Universidad Catlica de Chile
 *
 * lebrahm <at> uc <punto> cl
 * ICQ#50566818
 *
 * (CC)2006
 * 
 * */

import iic1102Package.*;
import java.io.*;

public class TablaDePosiciones {
	
	private static int MAX = 100; //cantidad mxima de equipos permitidos
	private static String AEQUIPOS = "equipos.txt";
	private static String ATABLA = "tablaDePosiciones.txt";

	public static void main(String[] args) throws IOException {
		
		Interfaz.MostrarMensaje("Comenzando el proceso de creacin de Tabla de Posiciones.");
		
		Interfaz.MostrarMensaje("Leyendo archivo de Equipos...");

		File archivo = new File(AEQUIPOS);
		
		//verificamos si el archivo existe y si tenemos acceso para leerlo
		if(!archivo.exists() || !archivo.canRead()) {
			Interfaz.MostrarMensaje("No se pudo abrir el archivo " + AEQUIPOS);
			//si no existe o no podemos abrirlo, retornamos para salir del programa
			return;
		}
		
		FileReader lector = new FileReader(archivo);
		BufferedReader buffer = new BufferedReader(lector);
		
		String linea;
		String[] equipos = new String[MAX]; //nombres

		int total = 0;
		
		linea = buffer.readLine();
		while(linea != null && total < MAX) {
			equipos[total] = linea;
			++total;
			linea = buffer.readLine();
		}
		
		lector.close();
		buffer.close();
		
		/*
		 * Ahora debemos preguntar los datos para cada equipo
		 * 
		 * En tabla se alcenar:
		 * PTS PJ PG PP PE GF GC DIF
		 * pero slo se pregunta al usuario por los datos necesarios
		 * para calcular la tabla.
		 * */
		int[][] tabla = new int[total][9];
		
		for(int i = 0; i < total; ++i) {
			
			Interfaz.MostrarMensaje("Equipo: " + equipos[i]);
			tabla[i][2] = Interfaz.PedirEntero("Partidos Ganados:");
			tabla[i][3] = Interfaz.PedirEntero("Partidos Perdidos:");
			tabla[i][4] = Interfaz.PedirEntero("Partidos Empatados:");
			tabla[i][5] = Interfaz.PedirEntero("Goles a Favor:");
			tabla[i][6] = Interfaz.PedirEntero("Goles en Contra:");
			
			//calculamos los datos que no nos dieron
			//PTS = 3*PG + PE
			tabla[i][0] = 3 * tabla[i][2] + tabla[i][4];
			//PJ = PG + PP + PE
			tabla[i][1] = tabla[i][2] + tabla[i][3] + tabla[i][4];
			//DIF = GF - GC
			tabla[i][7] = tabla[i][5] - tabla[i][6];

		}
		
		File nuevoArchivo = new File(ATABLA);
		PrintWriter imprimir = new PrintWriter(nuevoArchivo);

		imprimir.println("TABLA DE POSICIONES\r\n");
		imprimir.println("EQUIPO\t\tPTS\tPJ\tPG\tPP\tPE\tGF\tGC\tDIF\r\n");
		
		for(int i = 0; i < total; ++i) {

			linea = equipos[i] + "\t";
			for(int j = 0; j < 8; ++j) {
				linea += tabla[i][j];
				if(j != 7)
					linea += "\t";
			}
			
			imprimir.println(linea);

		}
			
		imprimir.close();
			
		
		Interfaz.MostrarMensaje("Enhorabuena!\nEl archivo " + ATABLA + " ha sido creado.");

	}

}
